/* Copyright 2015 Jason A. Donenfeld <Jason@zx2c4.com>. All Rights Reserved.
 * Copyright 2015 Cryptography Research, Inc.
 */

#ifndef CURVE448_H
#define CURVE448_H

#include <linux/types.h>

enum curve448_lengths {
	CURVE448_POINT_SIZE = (448 / 8)
};

bool curve448(uint8_t out[CURVE448_POINT_SIZE], const uint8_t secret[CURVE448_POINT_SIZE], const uint8_t basepoint[CURVE448_POINT_SIZE]);
void curve448_generate_secret(uint8_t secret[CURVE448_POINT_SIZE]);
void curve448_generate_public(uint8_t pub[CURVE448_POINT_SIZE], const uint8_t secret[CURVE448_POINT_SIZE]);

#endif
